*
      SUBROUTINE PAR_BDSV(NAME, N, NPROCS, BWL, BWU, NB, MMIN )
*
*        NB  
*          
*     PDDBSV, PDGBSV, PDPBSV
*
*  
      INTEGER            N, NPROCS, MMIN, NB, BWL, BWU
*      , BW
      CHARACTER*(*)      NAME
*
*   -  
      INTEGER           NPR
      PARAMETER         (NPR = 6)
*
*  
      INTEGER            I, IAM, IPA, IPB, IPW, IPWOR, IPPIV,
     $                   NP, NQ, NQRHS, NRHS, NB0, WORKSIZ,
     $                   LLD_A, LLD_B, LWORK, NPROW, NPCOL, NPROCS1
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = 1
      NPCOL = NPROCS
*
      IF( NPROCS .LT. N ) GO TO 9
      WRITE(NPR, FMT = *)' NPROCS .GE. N ! (  NPROCS !! )'
      GO TO 10
    9 NB0 = INT(REAL( N/NPROCS ))
      IF( NB .NE. 1 ) GO TO 8
      WRITE(NPR, FMT = *)' NB = 1 !  NB !!'
      GO TO 10
    8 IF( NB .EQ. 0 ) NB = NB0
*
      IF( NB .GE. 2 ) GO TO 7
      WRITE(NPR, FMT = *)' NB .LT. 2 !  NPROCS !!'
      GO TO 10
*
    7 IF( (N - NB*NPROCS) .EQ. 0 ) GO TO 5
      NPROCS1 = NPROCS - 1
      NB1 = INT(REAL( N/NPROCS1 ))
      IF( (N - NB1*NPROCS1) .NE. 0 ) GO TO 11
        NB = NB1
        NPROCS = NPROCS1
        NPCOL = NPROCS
        GO TO 5
   11   NB = NB1
        GO TO 5
*
*      IA=JA=IB=JB= 1
* NQRHS
*
    5 NRHS = 1
*
      LLD_B = NB
*
* LOCr
*      NP = LLD_A
* LOCc
      NQ = NB
*      NQRHS = NB
*
*    ( MMIN )
*
*    ()   B
      IPB = 1
*
* *NQRHS
*     A
      IPA = IPB + LLD_B*NRHS
*
      IF( NAME .NE. 'PDGBSV' ) GOTO 1
*
      LLD_A = 2*(BWL + BWU) + 1
      NP = LLD_A
*
*   ,    PDGBSV
*
      LWORK = (NB + BWU)*(BWL + BWU) + 6*(BWL + BWU)*(BWL + 2*BWU) +
     $        MAX(NRHS*(NB + 2*BWL + 4*BWU), 1)
*
*      
*   
      IPPIV = IPA + LLD_A*NB
      IPWOR = IPPIV + NB*NRHS
      GO TO 3
*
    1 IF( NAME .NE. 'PDDBSV' ) GOTO 2
*
      LLD_A = BWL + BWU + 1
      NP = LLD_A
*
*   ,    PDDBSV
*
      LWORK = NB*(BWL + BWU) + 6*MAX(BWL,BWU)*MAX(BWL,BWU) +
     $        MAX( (MAX(BWL,BWU)*NRHS), MAX(BWL,BWU)*MAX(BWL,BWU) )
*
      IPWOR = IPA + LLD_A*NB
      GO TO 3
*
    2 IF( NAME .NE. 'PDPBSV' ) GOTO 10
*
      LLD_A = BWL + 1
      NP = LLD_A
*
*   ,    PDPBSV
*
      LWORK = (NB + 2*BWL)*BWL + MAX((BWL*NRHS), BWL*BWL)
*
      IPWOR = IPA + LLD_A*NB
      GO TO 3
***
    3 IPW = IPWOR + LWORK
*
*     PDLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROCS, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB
         WRITE( NPR, FMT = * )'   IPB,  IPA,    IPWOR,  IPW,  MMIN' 
         WRITE( NPR, FMT = 9994 )IPB, IPA, IPWOR,  IPW, MMIN
         WRITE( NPR, FMT = * )'   BWL,  BWU,    BW'
         WRITE( NPR, FMT = 9994 )BWL, BWU, BW
         WRITE( NPR, FMT = 9991 )LWORK
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
*
   10 CONTINUE
*
 9992 FORMAT( / '      A X = B',
     $      '    ', A7/ )
 9998 FORMAT( /'     A ',I5,' *',I5,',',
     $       '    ',I3 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'  '/)
 9993 FORMAT( /'     ( )',
     $       ' NB = ',I2 // '     '/)
      RETURN
      END
